// Generated by CoffeeScript 1.12.7
(function() {
  var components, handleFreemailValidation, normalize, parse, parseDomain, parseEmail, stripRegex;

  parseEmail = require('email-addresses').parseOneAddress;

  parseDomain = require('domain-name-parser');

  normalize = require('../normalize');

  handleFreemailValidation = require('@activeprospect/freemail').handleFreemailValidation;

  stripRegex = /^\s+|\s+$/g;

  parse = function(string) {
    var addr, domain, freemailValidationData, parsed, ref, ref1, ref2;
    addr = parseEmail(string);
    freemailValidationData = handleFreemailValidation((ref = string.raw) != null ? ref : string);
    if (addr != null) {
      parsed = new String(string.toLowerCase().replace(stripRegex, ''));
      parsed.raw = (ref1 = string.raw) != null ? ref1 : string;
      parsed.user = addr.local;
      parsed.is_free = freemailValidationData.isFree;
      parsed.is_disposable = freemailValidationData.isDisposable;
      domain = parseDomain(addr.domain);
      parsed.domain = addr.domain;
      parsed.host = addr.domain.replace(new RegExp("\." + domain.tld + "$"), '');
      parsed.tld = domain.tld;
      parsed.valid = true;
    } else {
      parsed = new String(string);
      parsed.raw = (ref2 = string.raw) != null ? ref2 : string;
      parsed.valid = false;
    }
    return parsed;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }, {
      name: 'user',
      type: 'string',
      description: 'User name (everything to the left of @)'
    }, {
      name: 'domain',
      type: 'string',
      description: 'Domain name (everything to the right of @)'
    }, {
      name: 'host',
      type: 'string',
      description: 'Domain excluding top level domain'
    }, {
      name: 'tld',
      type: 'string',
      description: 'Top level domain (.com, .net, etc)'
    }, {
      name: 'is_free',
      type: 'boolean',
      description: 'Whether or not the email is from a free domain (ex: gmail, yahoo, etc)'
    }, {
      name: 'is_disposable',
      type: 'boolean',
      description: 'Whether or not the email is disposable'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is blank', 'is not blank', 'format is valid', 'format is invalid', 'includes', 'does not include', 'is included in', 'is not included in', 'matches pattern', 'does not match pattern'],
    examples: ['mikejones32@gmail.com', 'rcampbell1976@outlook.com', 'janets@somecompany.biz'].map(parse).map(normalize)
  };

}).call(this);
